#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    //cout << (13 >> 1); 6 (13 = 1101, 6 = 110)

    int n, q, a[30] = {0};
    cin >> n;
    vector<int> p(n);

    for(int i = 0; i < n; i++){
        cin >> p[i];
        for(int b = 0; b < 31; b++){
            if((p[i] >> b)%2 == 1) a[b]++;
        }
    }

    cin >> q;
    for(int i = 0; i < q; i++){
        int t;
        cin >> t;
        if(t == 0){
            int r = 0, k;
            cin >> k;

            for(int b = 0; b < 31; b++){
                if(a[b] >= k) r += (1 << b);
            }

            cout << r << endl;
        }
        else{
            int k, x;
            cin >> k >> x;
            k--;

            for(int b = 0; b < 31; b++){
                if((p[k] >> b)%2 != (x >> b)%2){
                    if((p[k] >> b)%2 == 0) a[b]++;
                    else a[b]--;
                }
            }
        }
    }
    return 0;
}